/*
 * sysrq.c - SysRQ code
 *
 * Added to the Zealos project and (C) by Reggy Ekkebus
 *
 * Current maintainer: Reggy Ekkebus <reggy@ekky.org>
 * Status: Maintained
 * Last update: 04/01/02
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Description:
 *
 * Notes/Fixme's:
 * Move over to generic/kern.
 * Make into a module by itself.
 * Needs fixing generally
 *
 * Changelog:
 * 30/09/01 Mark: Fixed stuff, fixed the formatting.
 */

#include <common.h>
#include <sysrq.h>
#include <desc.h>
#include <cpu.h>
#include <printk.h>
#include <kmalloc.h>


void do_sysrq(uchar scancode, struct allRegs *regs)
{
	switch (scancode) {
	case 19: /* 'r' Key */
		reboot(REBOOT_WARM);

	case 35: /* 'h' Key */
		halt();

	case 32: /* 'd' Key */
		dumpRegs(regs);
		break;

	case 31: /* 's' Key */
		dumpStack((ulong *)((ulong)regs + sizeof(regs)));
		break;

	case 50: /* 'm' Key */
#ifdef CONFIG_MM_STATS
		dump_stats();
#else /* CONFIG_MM_STATS */
#ifdef DEBUG
		printk(KINFO, "No mm stats - kernel not compiled with MM_STATS"
				" enabled.");
#endif /* DEBUG */
#endif /* CONFIG_MM_STATS */
		break;
	}
}

EXPORT_SYMBOL(do_sysrq);
