/*
 * assert.c - Handling of assertion failures
 *
 * Added to the Zealos project and (C) by Mark Zealey
 *
 * Current maintainer: Mark Zealey <mark@itsolve.co.uk>
 * Status: Maintained
 * Last update: 12/12/01
 *
 * Last CVS commit : $Id: assert.c,v 1.7 2002/02/19 16:46:32 jalh Exp $
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2 of the License, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Description:
 *
 * Notes/Fixme's:
 *
 * Changelog:
 *
 */


#include <common.h>

#ifdef DEBUG
#include <printk.h>

/* function: void assertError(int lev, char *expression, char *file, uint line)
 * description: Internal function, called by assert() and ASSERT()
 */
void assertError(uint lev, char *expression, char *file, uint line)
{
	printk(lev, "Assert (%s) failed in file %s at line %d\n", expression,
			file, line);
}

EXPORT_SYMBOL(assertError);
#endif /* DEBUG */
