/*
 * fuctions.c - Function handling functions
 *
 * Added to the Zealos project and (C) by Mark Zealey
 *
 * Current maintainer: Mark Zealey <mark@itsolve.co.uk>
 * Status: Maintained
 * Last update: 13/01/02
 *
 * Last CVS commit : $Id: functions.c,v 1.22 2002/02/19 16:46:32 jalh Exp $
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2 of the License, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Description:
 *
 * Notes/Fixme's:
 *
 * Changelog:
 *
 */

#include <common.h>
#include <debug.h>
#include <init.h>
#include <printk.h>

initFunc __preInitFunc funcInit()
{
	ulong i;
	struct func *syms;

	// And add all the kernel symbols in
	syms = (void *)&funcStart;

	for(i = 0; i < (memory)&funcLen / sizeof(struct func); i++) {
		DPRINT("%lu %s %p", i, syms[i].name, syms[i].address);
	}

	printk(KINFO, "Added %ld kernel symbols to the function table\n", i);

	return SUCCESS;
}
