/*
 * math.c - Maths routines (for in-kernel usage)
 *
 * Added to the Zealos project and (C) by Mark Zealey
 *
 * Current maintainer: Mark Zealey <mark@itsolve.co.uk>
 * Status: Maintained
 * Last update: 30/03/01
 *
 * Last CVS commit : $Id: math.c,v 1.4 2001/09/12 12:49:26 zion Exp $
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2 of the License, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Description:
 *
 * Notes/Fixme's:
 *
 * Changelog:
 *
 */

#include <common.h>

/* function: uint pow(uint x, uint y)
 * type: Global
 * description: Raises 'x' to the power of 'y'.
 */
uint pow(uint x, uint y)
{
	uint i=1;
	while(y-->0)
		i*=x;
	return i;
}

/* function: double floor(double f)
 * type: global
 * description: returns the 'floor' of the value given.
 */
double floor(double f)
{
	if(f<0)
		f--;
	
	return (double)((long)f);
}

EXPORT_SYMBOL(pow);
EXPORT_SYMBOL(floor);
