/*
 * syscall.c - A syscall implimentation
 *
 * Added to the Zealos project and (C) by Mark Zealey
 *
 * Current maintainer: Mark Zealey <mark@itsolve.co.uk>
 * Status: Maintained
 * Last update: 13/01/02
 *
 * Last CVS commit : $Id: syscall.c,v 1.9 2002/02/19 16:46:32 jalh Exp $
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2 of the License, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Description:
 *
 * Notes/Fixme's:
 *
 * Changelog:
 * 13/01/02 Mark: updated to not use offsets.
 */

#include <common.h>
#include <syscall.h>
#include <desc.h>
#include <device.h>
#include <init.h>
#include <debug.h>

extern handleInt(syscallInt);

errRet syscallReg(struct __expSyscall *syms)
{
	struct devNum t;
	t.major = major_syscall;
	t.minor = syms->num;
	return devReg(&t, syms->func);
}

initFunc syscallInit()
{
	struct __expSyscall *syms = (void *)&syscallStart;
	ulong i;
	errRet ret;

	for(i = 0; i < (memory)&syscallLen / sizeof(*syms); i++) {
		DPRINT("%lu: %lu %p\n", i, syms[i].num, syms[i].func);

		ret = syscallReg(syms + i);
		if(ret != SUCCESS)
			DPRINT("Registering syscall number %lu failed: %lu\n",
					syms[i].num, ret);
	}

	setIntGate(syscallInt, SYSCALL_INT, 3);

	return SUCCESS;
}

EXPORT_SYMBOL(syscallReg);
