/*
 * mm/init.c - Initalize memory management routines
 *
 * Added to the Zealos project and (C) by Mark Zealey
 *
 * Current maintainer: Mark Zealey <mark@itsolve.co.uk>
 * Status: Maintained
 * Last update: 12/12/01
 *
 * Last CVS commit : $Id: init.c,v 1.12 2002/02/19 16:46:32 jalh Exp $
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2 of the License, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Description:
 * This inits the memory, works out how much bitmap we need to have, allocates
 * it etc
 *
 * Notes/Fixme's:
 *
 * Changelog:
 */


#include <common.h>
#include <kmalloc.h>
#include <printk.h>
#include <cpu.h>
#include <init.h>
#include <mem.h>
#include <kernarea.h>
#include <machine.h>

// Tell the (l)user the memory size and init pages and slabs
initFunc __preInitFunc memInit()
{
	printk(KINFO, "Detected %luKb memory on your box.\n", thisBox.memCnt);
	pageTableInit();
	pageInit();
	slabInit();

	kernAreaAdd(kernelStart, kernelStart + kernelLength);

	return SUCCESS;
}
