; All sorts of debugging code

%ifdef DEBUG
; prints a dot ('.')
dot:
	push dx
	mov dx, '.'
	call write
	pop dx
	ret

; Dumps cx bytes of the contents of the memory beginning at fs:bx
dumpArea:
	push	ax
l0:
	mov	al, [fs:bx]
	call	writeNum
	inc	bx
	dec	cx
	cmp	cx, 0		; This nessecory?
	jne	l0
	pop	ax
	ret

printtoscreen:                  ; prints di:si contents one at a time
	lodsb                   ; lodsb puts ds:si in al

	or al,al                ; test if character is 0 (end)
	jz done

	;print it
	mov ah,0xe
	mov bx,0007             ; attribute
	int 0x10                ; BIOS print

	jmp printtoscreen       ; next char

done:
	ret
	
; Called w/ number in al
; Write a number in hex
writeNum:
	push dx
	mov	dl, al
	shr	dl, 4
	call	w
	mov	dl, al
	and	dl, 0xf
	call	w
	pop dx
	ret
	
w:	add	dl, '0'
	cmp	dl, '9'
	jle	end
	add	dl, 'A'-'0'-10
end:
	call write
	ret

; dl == char
write:
	push	ax
	push	bx
	mov	ah, 0xe
	mov	al, dl
	mov	bl, 0x7
	int	0x10
	pop	bx
	pop	ax
	ret
%endif

