/*
 * swap.c - arch-specific swap functions
 * 
 * Added to the Zealos project and (C) by Mark Zealey
 * 
 * Current maintainer: Mark Zealey <mark@itsolve.co.uk>
 * Status: Maintained
 * Last update: 12/12/01
 * 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * 
 * Description:
 * 
 * Notes/Fixme's:
 * 
 * Changelog:
 */

#include <common.h>
#include <swap.h>
#include <desc.h>
#include <cpu.h>
#include <printk.h>
#include <kmalloc.h>
#include <mem.h>
#include <kernarea.h>

//#undef PAGE_TEST
//#define PAGE_TEST


startExcept(pageFault, 14)
{
	ulong address;
	getCr(2, address);			// Get the requested address

	printk("cr2 is %8x, arg: %lu\n", address, arg);

	/* Because we loaded the kernel at 0x10000, we shouldn't be accessing
	 * the area < PAGE_SIZE. This is a good test, as usially this error will
	 * be caused by someone messing up on a linked list or something along
	 * those lines :-)
	 */
	if(address < PAGE_SIZE && inKernel(r->eip))
		printk(KERROR, "Unable to handle NULL-dereferance in-kernel\n");
	else
		printk(KERROR, "Eik, attempted to reference a page that "
				"doesn't exist\n");

	dumpRegs(r);		// Dump the *correct* regs
	disable_local_interrupts();		// Hang
	while(1);
}

initFunc swapInit()
{
	setIntGate(pageFault, 14, 3);
	swapSetup = TRUE;

#ifdef PAGE_TEST
	*(ulong *)1 = 0xdead;
#endif
	return SUCCESS;
}
