use strict;
use File::Copy;

my $nasm = 'nasm -f bin -DDEBUG';
my $boot = 'boot.asm.pre';
my $sec = 'sec.asm.pre';

sub mkelf {
	my ($file, $map, $image) = @_;
	open G, $file or die "Can't open $file for reading: $!";
	my $F = join '', <G>;
	close G;

	open F, '>'.$image or die "Can't open $image for writing: $!";
	print F $F;
	close F;
}

sub mkboot {				# FIXME: Horrid code!!
	my ($file, $map, $image, $config) = @_;
	my %data;

	# Multiboot, no bootloader needed
	if($config->{MULTIBOOT} and $config->{MULTIBOOT} ne 'N') {
		copy($file, $image);
		return
	}

	open F, $map or die "ACK!!, $!";

	$data{KERN_START} = (split ' ', (grep /_start/, <F>)[0])[0];
	$data{KERN_BSS_SIZE} = int((&getSect('.bss'))[1] / 512) + 1;
	$data{KERN_LOAD} = (&getSect('.text'))[0];
	$data{KERN_SIZE} = int((stat $file)[7] / 512) + 2;

	print map {"$_ => $data{$_}\n"} keys %data;

	my $tmp = parse($boot, \%data);
	my $tmpa = &mkTmp;
	system "$nasm -o $tmpa $tmp" and die "nasm1 failed, $!";
	unlink $tmp;

	$tmp = parse($sec, \%data);
	my $tmpb = &mkTmp;
	system "$nasm -o $tmpb $tmp" and die "nasm2 failed, $!";
	unlink $tmp;

	local $/ = undef;
	open F, $tmpa or die "$tmpa (temp file) doesn't exist.. argg";
	my $final = <F>;
	close F;
	unlink $tmpa;
	open F, $tmpb or die "$tmpb (temp file) doesn't exist.. argg";
	$final .= <F>;
	close F;
	unlink $tmpb;
	open F, $file or die "$file doesn't exist.. argg";
	$final .= <F>;
	close F;
	open F, ">$image" or die "Can't open $image for writing, $!";
	print F $final;
	close F;
}

sub mkTmp {
	my @chars = ('a'..'z', 'A'..'Z', 0..9);
	my $fn;
	
	do {
		$fn = join '', map {$chars[rand @chars]} 0..(4 + rand 4);
	} while -e "$fn.tmp";

	return "$fn.tmp";
}

sub parse {
	my ($inp, $data) = @_;
	my $tmp = mkTmp();
	open F, $inp or die "Can't open input file $inp: $!";
	open G, ">$tmp" or die "Can't open output file $tmp: $!";
	while(<F>) {
		s/\b([A-Z_]+)\b/(exists $data->{$1})?$data->{$1}:$1/eg;
		print G
	}
	close F;
	close G;
	return $tmp;
}

sub getSect {
	my $t = shift;
	seek F, 0, 0;
	$/ = "\n";
	@_ = grep /$t/, <F>;
	for(@_) {
		return (hex $1,hex $2) if /^$t\s*0x([\dA-Fa-f]+)\s*0x([\dA-Fa-f]+)\s*$/;
	}
	return (0,0);
}

sub bootClean {
	unlink <*.tmp>;
}
"A true value"
