/*
 * ata.h - ATA function definitions and global macros
 *
 * Added to the Zealos project and (C) by Mark Zealey
 *
 * Current maintainer: Mark Zealey <mark@itsolve.co.uk>
 * Status: Maintained
 * Last update: 04/01/02
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2 of the License, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Description:
 *
 * Notes/Fixme's:
 *
 * Changelog:
 */

#ifndef __ATA_H
#define __ATA_H

initFunc ATAInit();

/* Macro: ATA_MAX_DRV
 * Desc:  The maximum number of drives that can be controled by each controler
 * (It /is/ 2).
 */
#define ATA_MAX_DRV 2

/* Macro: ATA_MAX_CNT
 * Desc:  The maximum number of controlers that can be handled (and are probed).
 */
#define ATA_MAX_CNT 2

#define ATA_MINOR(c,d) (((((struct cntStr *)(c))->num * ATA_MAX_DRV) + (d)) *64)

#endif // __ATA_H
