/*
 * mc146818.h - Definitions specific to the MC146818 RTC driver.
 *
 * Added to the Zealos project and (C) by Mark Zealey
 *
 * Current maintainer: Mark Zealey <mark@itsolve.co.uk>
 * Status: Maintained
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2 of the License, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Description:
 * Time, include file
 *
 * Notes/Fixme's:
 *
 * Changelog:
 * 28/09/01 Mark: Created from time.h
 */

#ifndef __mc146818_H
#define __mc146818_H

#define TIME_SECONDS	0x00
#define TIME_MINUTES	0x02
#define TIME_HOURS	0x04
#define TIME_DAYS	0x07
#define TIME_MONTHS	0x08
#define TIME_YEARS_LOW	0x09
#define TIME_YEARS_HIGH	0x32
/* We fake this one */
#define TIME_YEARS	0xFF

#endif // __time_H
