/*
 * cpu.h - Generic CPU forward-declarations
 *
 * Added to the Zealos project and (C) by Mark Zealey
 *
 * Current maintainer: Mark Zealey <mark@itsolve.co.uk>
 * Status: Maintained
 * Last update: 04/01/02
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2 of the License, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Description:
 * see include/arch/kern/cpu.h
 *
 * Notes/Fixme's:
 *
 * Changelog:
 * 24/06/01 Mark: Moved some generic stuff over from include/i386/kern/cpu.h.
 * 11/12/01 Mark: Split some stuff out to system.h
 */

#ifndef __cpu_gen_H
#define __cpu_gen_H

#include <arch/kern/cpu.h>

initFunc CPUInit();
initFunc CPUDelaySetup();
void delay(ulong);
void udelay(ulong);

#endif /* !__cpu_gen_H */
