/*
 * functions.h - Generic function include
 *
 * Added to the Zealos project and (C) by Mark Zealey
 *
 * Current maintainer: Mark Zealey <mark@itsolve.co.uk>
 * Status: Maintained
 * Last update: 12/01/02
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2 of the License, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Description:
 *
 * Notes/Fixme's:
 *
 * Changelog:
 */

#ifndef __functions_H
#define __functions_H

initFunc funcInit();

struct func {
	char *name;
	void *address;
};

#if defined(__LOADER__) || defined(__MODULE__)
/* macro: EXPORT_SYMBOL(symbol)
 * desc: This is a *really* important macro which export's your symbol
 * (function) to the functions code so that it can be dynamically replaced
 */
#define EXPORT_SYMBOL(a)					\
char __funcStr_##a[] __SECTION__(".funcStrs") = #a;		\
struct func __func_##a __SECTION__(".funcSyms")			\
	= { __funcStr_##a, &a }

#else		// ERROR!
#define EXPORT_SYMBOL(a) error not_in_module_or_loader
#endif

#endif // __functions_H
