/*
 * hash.h - A generic set of functions for making hash-tables
 * 
 * Added to the Zealos project and (C) by Mark Zealey
 * 
 * Current maintainer: Mark Zealey <mark@itsolve.co.uk>
 * Status: Maintained
 * Last update: 04/01/02
 * 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * 
 * Description:
 * 
 * Notes/Fixme's:
 * 
 * Changelog:
 */

#ifndef __generic_kern_hash_H
#define __generic_kern_hash_H

#include <llist.h>

struct hashEntry {
	char *name;				// name
	ulong data;				// data we store in this entry
	LIST(struct hashEntry);			// Next entry
};

struct hash {
	ulong entries;				// Number of entrys
	struct hashEntry **entrys;		// The actual table
};

errRet hashAdd(struct hash *, char *, ulong);
errRet hashFind(struct hash *, char *, ulong *);
bool hashExists(struct hash *, char *);
errRet hashDel(struct hash *, char *);
struct hash *hashNew(ulong);
errRet hashOld(struct hash *);

#endif /* __generic_kern_hash_H */
