/*
 * Runtime kernel machine information
 *
 * Added to the Zealos project and (C) by Zwane Mwaikambo
 *
 * Current maintainer: Mark Zealey <mark@itsolve.co.uk>
 * Status: Maintained
 * Last update: 12/12/01
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2 of the License, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Description:
 *
 * Notes/Fixme's:
 * 10/09/01 Zwane: This is (hopefully) a start...
 * 13/09/01 Mark: Added to zealos
 *
 * Changelog:
 */

#ifndef __generic_machine_H
#define __generic_machine_H

/* typedef: machine
 * description: Contains info about the machine that you're currently on
 */
typedef struct {
	memory memCnt;
	__uint32 nrCPU;
	struct CPU **CPU;
} machine;

/* struct: thisBox
 * description: Contains the details about everything on this computer that
 * ZealOS is currently running on.
 */
extern machine thisBox;

#endif /* !__generic_machine_H */
