/*
 * majors.h - A listing of all the major's (device numbers) in use in the kernel
 *
 * Added to the Zealos project and (C) by Mark Zealey
 *
 * Current maintainer: Mark Zealey <mark@itsolve.co.uk>
 * Status: Maintained
 * Last update: 06/06/01
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2 of the License, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Description:
 * This file stores an enum of all of the majors and their uses. It is intended
 * to be used from user-space if major's are needed, as it will always be
 * in-sync with the kernel. - Mark
 *
 * Notes/Fixme's:
 *
 * Changelog:
 */

#ifndef __majors_H
#define __majors_H

enum {
	major_syscall = 0,	// Reserved for syscall interface
	major_ata,		// ATA drives list
	// Add more here - Mark
} majors;

#endif
