/*
 * math.h - In-kernel maths routines
 *
 * Added to the Zealos project and (C) by Mark Zealey
 *
 * Current maintainer: Mark Zealey <mark@itsolve.co.uk>
 * Status: Maintained
 * Last update: 04/01/02
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2 of the License, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Description:
 * This file is for maths routines that will be used in-kernel. It refers to
 *	functions in math.c and it also defines some other macros and includes
 *	the current arch's 64-bit implimentation
 *
 * Notes/Fixme's:
 *
 * Changelog:
 */

#ifndef __MATH_H
#define __MATH_H

#include <math64.h>

uint pow(uint,uint);
double floor(double);

/* Function: abs(num)
 * arg0: The number
 * description: Returns the absolute value of num (num with the - removed).
 */
#define abs(x) (((x)<0)?-(x):(x))

#endif
