/*
 * pci.c - Generic PCI stuff
 *
 * Added to the Zealos project and (C) by Zwane Mwaikambo
 * Parts (C) by Mark Zealey <mark@itsolve.co.uk>
 * Parts from Linux PCI header include/linux/pci_ids.h
 *
 * Current maintainer: Zwane Mwaikambo <zwane@commfireservices.com>
 * Status: Maintained
 * Last update: 06/11/01
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2 of the License, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Description:
 *
 * Notes/Fixme's:
 *
 * Changelog:
 * 06/11/01 Mark: s/PCI_VENDOR_ID_UNKNOWN/PCI_VENDOR_ID_INVALID/
 */

#ifndef __generic_pci_H
#define __generic_pci_H

#include <arch/kern/pci.h>

/* Vendor IDs - lifted from include/linux/pci_ids.h */

#define PCI_VENDOR_ID_REALTEK           0x10ec
#define PCI_VENDOR_ID_COMPAQ            0x0e11
#define PCI_VENDOR_ID_ATI               0x1002
#define PCI_VENDOR_ID_IBM               0x1014
#define PCI_VENDOR_ID_AMD               0x1022
#define PCI_VENDOR_ID_TRIDENT           0x1023
#define PCI_VENDOR_ID_MATROX            0x102B
#define PCI_VENDOR_ID_HP                0x103c
#define PCI_VENDOR_ID_ASUSTEK           0x1043
#define PCI_VENDOR_ID_PROMISE           0x105a
#define PCI_VENDOR_ID_YAMAHA            0x1073
#define PCI_VENDOR_ID_CYRIX             0x1078
#define PCI_VENDOR_ID_BROOKTREE         0x109e
#define PCI_VENDOR_ID_3COM              0x10b7
#define PCI_VENDOR_ID_SMC               0x10b8
#define PCI_VENDOR_ID_MACRONIX          0x10d9
#define PCI_VENDOR_ID_NVIDIA		0x10de
#define PCI_VENDOR_ID_CREATIVE          0x1102
#define PCI_VENDOR_ID_VIA               0x1106
#define PCI_VENDOR_ID_IDT               0x111d
#define PCI_VENDOR_ID_XIRCOM            0x115d
#define PCI_VENDOR_ID_SERVERWORKS       0x1166
#define PCI_VENDOR_ID_TOSHIBA           0x1179
#define PCI_VENDOR_ID_3DFX              0x121a
#define PCI_VENDOR_ID_ESS               0x125d
#define PCI_VENDOR_ID_ROCKWELL          0x127A
#define PCI_VENDOR_ID_USR               0x12B9
#define PCI_VENDOR_ID_AUREAL            0x12eb
#define PCI_VENDOR_ID_NETGEAR           0x1385
#define PCI_VENDOR_ID_3WARE             0x13C1
#define PCI_VENDOR_ID_CMEDIA            0x13f6
#define PCI_VENDOR_ID_TEKRAM            0x1de1
#define PCI_VENDOR_ID_AVANCE            0x4005
#define PCI_VENDOR_ID_S3                0x5333
#define PCI_VENDOR_ID_INTEL             0x8086
#define PCI_VENDOR_ID_ADAPTEC           0x9004
#define PCI_VENDOR_ID_ADAPTEC2          0x9005
#define PCI_VENDOR_ID_SIS               0x1039
#define PCI_VENDOR_ID_INVALID		0xFFFF

#endif /* __generic_pci_H */
