/*
 * printk.h - printk header file
 *
 * Added to the Zealos project and (C) by Mark Zealey
 *
 * Current maintainer: Mark Zealey <mark@itsolve.co.uk>
 * Status: Maintained
 * Last update: 04/01/02
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2 of the License, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Description:
 *
 * Notes/Fixme's:
 *
 * Changelog:
 */

#ifndef __printk_H
#define __printk_H

errRet printk(uint lev, char *, ...) /*checkArgs(printf, 2, 3)*/;

#define KINFO 1
#define KDEBUG 2
#define KWARN 3
#define KERROR 4
#define KPANIC 5

/* function: panic(str...)
 * description: panic the kernel with the specified arguments (same as
 * printk(KPANIC, str...)
 */
#define panic(x...) printk(KPANIC, ##x)

#endif // __printk_H
