/*
 * sched.h - Header file for the scheduler
 *
 * Added to the Zealos project and (C) by Mark Zealey
 *
 * Current maintainer: Mark Zealey <mark@itsolve.co.uk>
 * Status: Maintained
 * Last update: 04/01/02
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2 of the License, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Description:
 *
 * Notes/Fixme's:
 *
 * Changelog:
 * 12/09/01 Zwane: added "thisBox" support, plus a few evil things ;) ...
 */

#ifndef __sched_H
#define __sched_H

#include <llist.h>
#include <task.h>

#define SCHED_MAX_PRIO	30
#define SCHED_MIN_PRIO	0	// will never run
#define SCHED_DEF_PRIO	2

#define SCHED_KICKBACK	8	// at reschedule time chance -= this

#define MAX_CHANCE	5000	// this keeps the tasks 'chance' in line ;)

struct task {
	void *stack;
	ulong eip;
	ulong stackLen;
	void *stackBase;
	ulong chance, prio;
	struct archTask arch;
	LIST(struct task);
};

void schedule();
initFunc schedInit();

typedef struct {
	void (*scheduler)();	/* the scheduler we're using... */
	/* any other globals here ... */
} __PACKED__ SCHEDData_t;

SCHEDData_t *SCHEDData;

#endif /* !__sched_H */
