/*
 * stdio.h - Definitions of standard routines
 *
 * Added to the Zealos project and (C) by Mark Zealey
 *
 * Current maintainer: Mark Zealey <mark@itsolve.co.uk>
 * Status: Maintained
 * Last update: 04/01/02
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2 of the License, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Description:
 *
 * Notes/Fixme's:
 *
 * Changelog:
 */

#ifndef __STDIO_H
#define __STDIO_H

#ifdef GDB_REMOTE_OUT
void gdb_puts(char *);
#define puts(x) gdb_puts(x)
#else
#include <video.h>
#define puts(x) putsColor(x, FG(cNormal) | BG(cBlack))
#endif

void putsColor(char *, __uint8);
ulong atoi(char *, __uint8);
/*void printf(char *, ...) checkArgs(printf, 1, 2);*/
void sprintf(char *, char *, ...) checkArgs(printf, 2, 3);
void vsprintf(char *, char *, char *);
bool kstrcmp(char *, char *);
bool kbeginswith(char *, char *);
void kstrcopy(char *, char *);
void kmemcopy(char *, char *, ulong);
ulong length(char *);
char toLower(char );
char toUpper(char );
char *strToUpper(char *);
char *strToLower(char *);
void bts(char *, ulong);
void btc(char *, ulong);
bool bt(char *, ulong);
ulong chomp(char *);
ulong chompl(char *, ulong);
ulong kmemset(char *, char, ulong);
void kmemdump(char *, ulong);

#endif
