/*
 * syscall.h - Header file for syscalls
 *
 * Added to the Zealos project and (C) by Mark Zealey
 *
 * Current maintainer: Mark Zealey <mark@itsolve.co.uk>
 * Status: Maintained
 * Last update: 13/01/02
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2 of the License, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Description:
 *
 * Notes/Fixme's:
 *
 * Changelog:
 */

#include <device.h>
#include <arch/kern/syscall.h>

#ifndef __syscall_H
#define __syscall_H

enum syscalls {
	__NR_clone = 0,
	__NR_dump,
};

struct __expSyscall {
	devHandler *func;
	minor num;
};

initFunc syscallInit();
errRet syscallReg(struct __expSyscall *);

#define syscallFunc(x)							\
errRet asmLinkage x(struct devNum *num, struct allRegs *regs);		\
EXPORT_SYMBOL(x);							\
struct __expSyscall __syscall_##x __SECTION__(".syscalls")		\
	= { x, __NR_##x };						\
errRet asmLinkage x(struct devNum *num, struct allRegs *regs)

#endif
