/*
 * apic.h - Local APIC functions
 *
 * Added to the Zealos project and (C) by Zwane Mwaikambo
 *
 * Current maintainer: Zwane Mwaikambo <zwane@commfireservices.com>
 * Status: Maintained
 * Last update: 16/10/01
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2 of the License, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Description:
 *
 * Notes/Fixme's:
 *
 * Changelog:
 */

#ifndef __i3_apic_H
#define __i3_apic_H

#define APIC_BASE_MSR		0x1B	// MSR register number

/* The following are the bitfields from the qword returned from this MSR */
#define APIC_BASE_MSR_FLAG_BSP	0x08	// Wether CPU is BSP
#define APIC_BASE_MSR_FLAG_GE	0x11	// Global Enable. If set we can dis/en
#define APIC_BASE_MSR_ADDR	0x12	// APIC base address	

#define APIC_ADDRESS_MAP	0xFEE00000	/* the starting point 1st CPU, 2nd is 4k up etc..*/
#define _APIC_ADDRESS_MAP(x)	(APIC_ADDRESS_MAP + (x * 0x1000))
#define APIC_ID_REG		0xFEE00020	/* local APIC ID register */
#define APIC_VERSION		0xFEE00030	/* local APIC version */
#define APIC_EOI_REG		0xFEE000B0	/* EOI register */
/* spurious interupt vector reg, bit 8 is used for en/disabling the local APIC */
#define APIC_SIV_REG		0xFEE000F0

#endif /* __i3_apic_H */
