/*
 * video.h - i386 video routines
 *
 * Added to the Zealos project and (C) by Mark Zealey
 *
 * Current maintainer: Mark Zealey <mark@itsolve.co.uk>
 * Status: Maintained
 * Last update: 04/01/02
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2 of the License, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Description:
 *
 * Notes/Fixme's:
 *
 * Changelog:
 */

#ifndef __VIDEO_H
#define __VIDEO_H

void putcColor(char, __uint8);
void cls();
initFunc videoInit();

/* Macro: cBlack cBlue cGreen cRed cMagenta cBrown cBright cFlash
 * Description: Defined the colour so you can putcColor() using the FG()
 * and BG() macros to specify the colours you want the character to be displayed
 * with. When |'ing any of these with cBright, makes the colour brighter. cFlash
 * makes the overall code clash (don't put it inside a BG() or FG() statment.
 */
#define cBlack 0
#define cBlue 1
#define cGreen 2
#define cCyan 3
#define cRed 4
#define cMagenta 5
#define cBrown 6
#define cNormal 7
#define cBright 8
#define cFlash 128

/* Macro: FG(colour)
 * arg0: A colour code (cBlack, cCyan, etc..)
 * description: Makes the specified colour the forground colour for putcColor().
 */
#define FG(x) (x)

/* Macro: FG(colour)
 * arg0: A colour code (cBlack, cCyan, etc..)
 * description: Makes the specified colour the background colour for
 * putcColor().
 */
#define BG(x) (x << 4)

/* function: putc(char)
 * arg0: Character to put to the screen
 * description: Puts a charater to the screen with background colour cBlack and
 * forground colour normal (grey-white). (Just calls putcColor())
 */
#define putc(x) putcColor(x, FG(cNormal) | BG(cBlack))

#endif
