/*
 * arch_common.h - Arch-specific defines etc
 *
 * Added to the Zealos project and (C) by Mark Zealey
 *
 * Current maintainer: Mark Zealey <mark@itsolve.co.uk>
 * Status: Maintained
 * Last update: 10/12/01
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2 of the License, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Description:
 * A file which contains all of the basic info for the mips systems
 *
 * Notes/Fixme's:
 *
 * Changelog:
 */

#ifndef __ARCH_COMMON_H
#define __ARCH_COMMON_H

typedef char __int8;
typedef short __int16;
typedef long __int32;
typedef long long __int64;

typedef unsigned char __uint8;
typedef unsigned short __uint16;
typedef unsigned long __uint32;
typedef unsigned long long __uint64;

// What you cast a void * to to be able to read it 'normally'
typedef ulong memory;

#define BYTE_ORDER 0		// We're on a little-endian box

#define ARCH_BITS 32		// 32-bit arch :)

/* macro: BREAKPOINT()
 * desc: This causes a breakpoint to happen in the kernel. Usually used while
 * remote-gdb'ing.
 */
#define BREAKPOINT() asm("break");

/* No cycle count on mips... */
#undef HAVE_CYCLE_COUNT

#endif	// __ARCH_COMMON_H
