/*
 * spinlock.h - Simple spinlock implementation - mips-specific
 *
 * Added to the Zealos project by and copyright Mark Zealey
 *
 * Current maintainer: Mark Zealey <mark@zealos.org>
 * Status: Maintained
 * Last update: 10/12/01
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2 of the License, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Description:
 *
 * Notes/Fixme's:
 *
 * Changelog:
 * 10/12/01 Mark: Created
 */

#ifndef __spinlock_H
#define __spinlock_H

#define SPINLOCK_LOCKED		0
#define SPINLOCK_UNLOCKED	1

#define INIT_LOCKED		{}
#define INIT_UNLOCKED		{}

typedef struct {
} spinlock_t;

#define spinlock(x) do { } while(0)
#define spinlockUnlock(x) do { } while(0)

/* Higher-level things, these are needed on both SMP and UP boxes */
static inline void spinlockIRQSave(spinlock_t *lock, ulong *flags)
{
	*flags = getEFlags();
	__local_cli();
	spinlock(lock);
}

static inline void spinlockIRQRestore(spinlock_t *lock, ulong *flags)
{
	spinlockUnlock(lock);
	setEFlags(*flags);
}

#endif /* __spinlock_H */
