package Parse;
use strict;
use Carp;

sub retFile {
	my $file = shift;
	open F, $file or croak "Can't open $file, $!";
	my @ret = <F>;
	close F;
	return @ret;
}

sub splitter {
	my ($beg, @str) = @_;
	my @ret;
	
	for(split ' ', (join ' ', @str)) {
		if(m!^(\Q$beg\E|include)/!) {
			push @ret, $_
		} else {
			push @ret, (/\.h$/ and 'include/') . "$beg/$_"
		}
	}
	return @ret;
}

sub Mod_deps {
	my ($prev, %mod_depend);
	my ($beg, $mod_depend) = @_;

	# Grab file contents
	my @mod_depend = grep !/^#/, retFile("$beg/$mod_depend");

	my ($e, $end);

	for(@mod_depend) {		# Parse dependancies
		chomp;
		next unless $_;
		my $str;
		$end = $e;
		next unless ($str, $e) = /^(.*?)(\\?)$/;
		if(defined $end and $end eq '\\') {	# Continuation
			push @{$mod_depend{$prev}}, splitter($beg,$str);
		} elsif($str =~ /^\s*(.*?)\s*:\s*(.*?)$/) {
			$mod_depend{$1} = [splitter($beg,$2)];
			$prev = $1;
		} else {
			carp "$_ is un-parsable, skipping";
			next;
		}
	}

#	for $prev (keys %mod_depend) {
#		print "$prev: ";
#		print "$_ " for @{$mod_depend{$prev}};
#		print "\n";
#	}

	return %mod_depend;
}

sub Config {
	my $config = shift || 'config';
	return () unless -f $config;
	my @config = grep !/^#/, retFile($config);
	my %config;
	my $skip = 1;

	for(@config) {		# Parse config
		chomp;
		s/#.*//;
		next unless /^\s*(.*?)\s*=\s*(.*?)\s*$/i;
		$config{$1} = $2;
	}
	return %config;
}

"A true value"
