/*
 * task.c - A task implimentation for x86-64
 *
 * Added to the Zealos project and (C) by Mark Zealey
 *
 * Current maintainer: Mark Zealey <mark@itsolve.co.uk>
 * Status: Maintained
 * Last update: 29/06/01
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2 of the License, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Description:
 * The FIXME file
 *
 * Notes/Fixme's:
 * mark: Just look thru the file... :)
 *
 * Changelog:
 */

#include <common.h>
#include <task.h>
#include <printk.h>
#include <desc.h>
#include <cpu.h>
#include <stdio.h>
#include <syscall.h>
#include <kmalloc.h>

#define startStackSize 4092


void idle()
{
	while(1) /* do nothing */ ;
}

void fastCall __taskSwitch(struct task *prev, struct task *next)
{
	curCPU->arch.TSS.esp0 = (__uint32)next->stack;

	getSeg("fs", prev->arch.fs);
	getSeg("gs", prev->arch.gs);
	loadSeg("fs", next->arch.fs);
	loadSeg("gs", next->arch.gs);
}

errRet kernThread(void (*func)(), void *arg)
{
	ulong ret;

	asm("int $" STR(SYSCALL_INT) : "=a" (ret) : "a" (__NR_clone), "b" (func));
	return ret;
}

// FIXME
/*errRet kernThread(void (*func)(), void *arg)
{
	volatile ulong t;
	errRet ret;

	t = getStackPointer();
	syscall(clone);
	WRITE_BARRIER();
	if(t == getStackPointer())	// Parent thread
		return SUCCESS;

	cli();
	setReg("esp", getStackPointer() + 4);
	printk("b: %lx\n", *((ulong*)getStackPointer() + 4));
	printk("%p\n", func);
	sti();
	(*func)();
	while(1);

	asm volatile(
*/			/* Save stack */
//			"movl %%esp, %1		\n"
			/* clone */
//			"int $" STR(SYSCALL_INT) "	\n"
			/* Check to see if we are daddy or not */
//			"cmpl %%esp, %1			\n"
			/* If we are, carry on */
//			"je 1f				\n"
//			"popl %%eax			\n"	// ???
			/* Pass reg in both eax and on the stack */
//			"movl %4, %%eax			\n"
//			"pushl %%eax			\n"
			/* Call it!! */
//			"call *%3			\n"
			/* Maybe mop up ? */
//			"2: jmp 2b			\n"
			/* Escape place */
/*			"1:				\n"
			: "=a" (ret), "=S" (t)
			: "a" (__NR_clone), "b" (func), "r" (arg)
			: "memory");
	return ret;
}*/

syscallFunc(dump)
{
	dumpRegs(regs);
	return SUCCESS;
}

syscallFunc(clone)
{
	struct task *t;
	void *s;

	t = kmalloc(sizeof(struct task));
//	t->eip = regs->eip;	// FIXME!!
	t->eip = regs->ebx;
	// FIXME!!!
	s = kmalloc(1024);
	t->stack = s + 1024 - sizeof(struct allRegs);
//	kmemset(s, 0, 1024);		// Not needed?
	kmemcopy(t->stack, regs, sizeof(struct allRegs));
	t->prio = 5;

	t->next = curCPU->curTask->next;
	curCPU->curTask->next = t;

	return SUCCESS;
}

void taskStartup()
{
	kmemset(&curCPU->arch.TSS, 0, sizeof(struct TSS));
	curCPU->arch.TSSGDTEntry = GDTAddEntry(&curCPU->arch.TSS,
				sizeof(struct TSS), FALSE, FALSE, 9, 0, FALSE);

	ltr(curCPU->arch.TSSGDTEntry);

	curCPU->curTask = kmalloc(sizeof(struct task));
	curCPU->curTask->prio = 30;
	curCPU->curTask->next = curCPU->curTask;

	kernThread(idle, NULL);
}
